<template>
   <div id="app" class="container">
    <div class="page-header">
    </div>
    <div class="panel panel-default">
      <div class="panel-heading">
        <h3 class="panel-title">Adicionar Conta</h3>
      </div>
      <div class="panel-body">
         <b-form id="form" class="form-inline" v-on:submit.prevent="addAccount">
          <div class="form-group">
            <label for="accountUserId">Cliente:</label>
            <select class="form-control" id="accountUserId" v-model="newAccount.user_id">
                <option v-for="user in users" v-bind:key="user['.key']" :value="user['.key']">{{user.name}}</option>
            </select>
          </div>
          <div class="form-group">
            <label for="accountPrice">Mês:</label>
            <select class="form-control" id="accountMonth" v-model="newAccount.month">
                <option>1</option>
                <option>2</option>
                <option>3</option>
                <option>4</option>
                <option>5</option>
                <option>6</option>
                <option>7</option>
                <option>8</option>
                <option>9</option>
                <option>10</option>
                <option>11</option>
                <option>12</option>
            </select>
          </div>
          <input type="submit" class="btn btn-primary" value="Adicionar">
        </b-form>
      </div>
    </div>
    <br>
    <br>
    <div class="panel panel-default">
      <div class="panel-heading">
        <h3 class="panel-title">Lista de contas</h3>
      </div>
      <div class="panel-body">
        <table class="table table-striped">
          <thead>
            <tr>
              <th>Cliente</th>
              <th>Mês</th>
              <th>Total</th>
              <th>Ações</th>
            </tr>
          </thead>
          <tbody>
            <tr v-for="account in accounts" :key="account.id">
              <td>{{account.user_name}}</td>
              <td>{{account.month}}</td>
              <td>R$ {{account.amount}}</td>
              <td>
                <router-link :to="{ name: 'EditAccount', params: {id: account['.key']} }" class="btn btn-warning">
                  Conta
                </router-link>
                <span class="btn btn-primary" v-on:click="removeAccount(account)">Remover</span>
              </td>
            </tr>
          </tbody>
        </table>
      </div>
    </div>
  </div>
</template>

<script>
import toastr from 'toastr';
import { db } from '/home/carolina/Documentos/zrp/repositorios/account-manager/src/config/db';

let accountsRef = db.ref("accounts");
let usersRef = db.ref("users");

export default {
  name: "App",
  firebase: {
    accounts: accountsRef,
    users: usersRef
  },
  data() {
    return {
      newAccount: {
        user_id: "",
        user_name: "",
        productsArray: [],
        month: "",
        amount: 0.00
      }
    };
  },
  methods: {
    getUserName: function(id){
      return this.users.filter(user=> user['.key'] === id)[0].name; 
    },
    addAccount: function() {
      this.newAccount.user_name = this.getUserName(this.newAccount.user_id);
      accountsRef.push(this.newAccount);
      this.newAccount.user_id = "";
      this.newAccount.productsArray = [];
      this.newAccount.month = "";
      this.newAccount.amount = "";
    },
    removeAccount: function(account) {
      accountsRef.child(account[".key"]).remove();
      toastr.success("Conta removida com sucesso");
    }
  }
};
</script>
<style>
#app {
  font-family: "Avenir", Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
  margin-top: 60px;
}
</style>
